#!/usr/bin/perl 
use Getopt::Long;
require "Mailhash.pl";
require "Pfrom.pl";
#############################################################
# ver 1.0.6
# Changes....
# Fixes some of the bugs that i have encountered, ex
# with people who has the same hash but only one sender,
# the fixs is done at row 466.
# on row 277 i added that users that are unknown should be 
# logged to so they want be undefined....
# there are still some bugs but im working on it......
# ive done some more debugging , and found some bugs wich i have 
# updated.....
# ###########################################################
# any questions please mail me at calle@volvo.se
# 
# If you do any changes please notify me and maybe i could
# add them to the original.
#
# this is a script to see wich persons sends and
# Gets most mails.
#
# I use it to see if some unusual mail delivery has occured.
# or if there is mailoops.
# 
# if you want to see all the users that sends through the host
# remove the [0..$HOW_MANY] from line 285.
#
#############################################################
# How To: mailoop.pl --file <maillog> --top <sent,size,amount> --rows <nr> 
#
#--file <maillog> 
#
# --rows <How many rows the output should have> (integer)
#  this is the top users, then it shows the top xx users
#  default is 50
#
# --sort <amoutn/size> wich to sort on, amoutn= how many mails from each
# user to another user, size= the amoutn of the messgaes.
# 
#############################################################
# TODO:
# i want to get in the stats but it seems like i have
# to rearrange the output because i have a hard time to fit
# all the data on the screen...
#############################################################
# Thanks:
# I also want to thank Olof for the reg.exp. that he made,
# and i stole!!! ( i asked him first).
#############################################################


my $USAGE = "Use $0 
--file <maillog> \n
--rows <How many rows the output should have> (integer)\n
  this is the top users, then it shows the top xx users\
  default is 50\n
--debug <yes/no> just a way to see the program react..\n
--sort <amount/size>\n

";
########################################
########## some variables
########################################

my %ID;
my %TUSER;
my %msg;
my $SORTING;
my $TOTAL_S=0;
my $TOTAL_MSG=1;


########################################
########################################







die "Bad Option, use \"$0 --help\" for help\n" unless
  GetOptions ( 'help!' => \$help,
	       'file=s' => \$LOG_FILE,
	       'rows=i' => \$HOW_MANY,
	       'debug=s' => \$DEBUG,
	       'sort=s' => \$SORTING,
	       'plug=s' => \$PLUG );


if ( (defined($help)) | (!defined($LOG_FILE)) ) {
  print $USAGE;
  exit 0;
}

if (!defined($HOW_MANY) ) {
  $HOW_MANY=100;
}
if (!defined($SORTING)) {
  $SORTING='amount';
}

	    



  
# Thanks to Olof Samuelsson, this might be a good way to
# handle messages?? 
# even if it is kind of wild..

sub parse_msg {
  return map {
    split(/=/, $_, 2)
  } ( $_[0] =~ m'(\w+=.*?)(?=(?:, [a-z]+=)|$)'g );
  
  # This is a list extraction regexp, it returns the individual
  # words in a sendmail log message.  It extract all aaa=bla blo
  # followed by another ,bbb= This is the best way I've found so
  # far, since the rows of the line may contain embedded ", " These
  # key=val reords are then splitted into (key, val) and returned
  # as a list, suitable for treatment as a hash.  The (?=) is a
  # positive forward assertion, and the (?:) is a grouping without
  # affecting $& and friends.
  
}


  
  

########################################
# sub: Open_log
# Author: calle Olsen
# Date 001202 (yymmdd)
#
# Describtion: read the logs and store evry message in 
# object ex. a object i created with the message id as an hash
# in the object there are 2 feilds "to" and "from
# in these feilds the to user are stored and the from user..
########################################

sub OPEN_LOG {
  # Open the log for read and the put evry line into $line

  open  LOG , $LOG_FILE or die "could not find the file $LOG_FILE\n";



  while ( $line =  <LOG> ) {
# while reading the lines it will be split uped  
# 
    chomp $line;
    my (undef,$UD,$message) = split(/: /, $line, 3);
    $message = lc ($message);

    #If the log starts with "to" it should then read this
    # create object one object that is based on the 
    # HASH wich sendmail logs write out its actually
    # the message ID
    # $UD = message HASH from sendmail Log
    # $message = the rest of the message

   
    if (defined($message)) {
      
   
      if ( $message =~ /^to/ ) {
	%msg=();
	
	# Send the messgae line to Olofs split function....
	
	%msg = parse_msg($message);
	
		
	if ( !($ID{$UD}) ) {
	  $ID{$UD} = mailHash -> new ( to=>$msg{to} );
	  
	  if ($DEBUG) {
	    print " added a new object to", $ID{$UD}," the hash is $UD\n";
	  }
	  
	}elsif ( ($ID{$UD}) ) {
	  $ID{$UD} -> add_To ( $msg{to} );
	  
	  if ($DEBUG) {
	    print " added a \"to\" to the object $ID{$UD}\n"
	  }
	}

      
	#If the log line starts with "from" then it should do this.......
      	
      }elsif ( $message =~ /^from/ ) {
	%msg=();
	%msg = parse_msg($message);
	
	
	if ( !($ID{$UD}) ) {
	  $ID{$UD} = mailHash->new (from=>$msg{'from'},size=>$msg{'size'} );
	  
	  if ($DEBUG) {
	    print " added a new object from", $ID{$UD}," the hash is $UD\n";
	  }
	  
	}elsif ( ($ID{$UD}) ) {
	  $ID{$UD} -> add_From ( $msg{'from'} );
	  
	  if ($DEBUG) {
	    print " added a \"from\" to the object $ID{$UD}\n"
	  }
	}
	
	
      }elsif ( $message =~ /dsn/ ){
	if ($DEBUG) {
	  warn "A DSN Message\n";
	}
	

	#here is some bug fixes
	# if the message is sent to a person who is unknown the 
	# first version will spit it out without giving any good reason
	# this time i added so the person will be loged too but only
	# it will say that its unknown

      }elsif ( $message =~ /(unknown)$/ ) {
	$msg{'to'}=$message;
	
	if ( !($ID{$UD}) ) {
	  $ID{$UD} = mailHash -> new (to=>$msg{to} );
	  
	  if ($DEBUG) {
	    print " added a new object to", $ID{$UD}," the hash is $UD\n";
	  }
	  
	}elsif ( ($ID{$UD}) ) {
	  $ID{$UD} -> add_To ( $msg{to} );
	  
	  if ($DEBUG) {
	    print " added a \"to\" to the object $ID{$UD}\n"
	  }
	}
	#here it ends!
	# this belongs to ver1.0.5

      }else {
	if ($DEBUG) {
	  warn "This is strange $message\n";
	}
      }
    

    
    }
  }
}


########################################
# sub: Get_all
# Date: 001102
# Author: Calle Olsen
#
# Description: Reads each of the hashes that was made in OPEN_LOG
# and creates a new object ( if its not already created ).
# the object is stored in a hash %TUSER wich has the to user as the key
# and the element is the object wich has 2 fields, "from" wich contains the
# from user and the amount wich contains the amount of mail between
# the hash value and object filed from....
########################################

sub Get_all {
  foreach $OH ( keys %ID ) {
    my $to = $ID{$OH}->{'to'};
    my $from = $ID{$OH}->{'from'};
    my $size = $ID{$OH}->{'size'};

    $TOTAL_S = $TOTAL_S + $size;
    $TOTAL_MSG++;

    if(!$from) {
      $from="undefined";
      print "undefined has been encountred\n";
    }



    if ($DEBUG) {
      print "to: ",$ID{$OH}->{'to'}, " from: ",$ID{$OH}->{'from'}," HASH: $OH\n";
    }
    
    if(exists($TUSER{$to}) && $to !~ /undefined/ ) {   # if the hash with exists 
      my $HASH_SIZE=$TUSER{$to}->size;
      my $TOTAL_SIZE=$HASH_SIZE+$size;
      my $tmp=$TUSER{$to}->amount;
      $tmp++;
      $TUSER{$to}->amount($tmp);
      $TUSER{$to}->size($TOTAL_SIZE);
      # count up the mail for tat user....

      if ($DEBUG) {
	print " From user ", $TUSER{$to}->from ," to user : ", $to, " amount ", $TUSER{$to}->amount,"\n"
      }
      
      
    }elsif(!exists($TUSER{$to}) && $to !~ /undefined/ ){
      # there is no record yet so lets create one...
      $TUSER{$to}= FROM->new();
      $TUSER{$to}->from($from);
      $TUSER{$to}->amount(1);
      $TUSER{$to}->size($size);

      # end of creation of user object...

      if ($DEBUG) {
	print "Created a new from object: ", $TUSER{$to}->from," the amount of mail ",$TUSER{$to}->amount,"\n"; 
      }

      

    }
  }
}


########################################
########################################
# Sub: sort_logs
# Date: 001102
# Author: Calle Olsen
#
# Description: Sorts the output from the object "amount" and then writes it out.
########################################
########################################

sub Sort_logs {
  
  open OUT, ">&STDOUT";
  if ($SORTING eq "size") {
    
    foreach $KEY (( sort { $TUSER{$b}->size <=> $TUSER{$a}->size }
		    keys %TUSER)[0..$HOW_MANY]) {
      write OUT;
    }
    
  } else {
    foreach $KEY (( sort { $TUSER{$b}->amount <=> $TUSER{$a}->amount }
		    keys %TUSER)[0..$HOW_MANY]) {
     
      write OUT;
    }
  }
  close OUT;
  open ALL, ">&STDOUT";
  write ALL;
  close ALL;
#  print "Total size: $TOTAL_S Total Messages: $TOTAL_MSG Size/message: ",int($TOTAL_S/$TOTAL_MSG),"\n";
}

########################################
########################################

########################################
########################################
# Format output.....
########################################
########################################
format OUT_TOP =
 From:                                                        To:                    Mail Sent  Total sent size
----------------------------------------  ----------------------------------------  ----------- ---------------
.

format OUT =
@<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< @<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<  @|||||||||  @>>>>>>>>> 
$TUSER{$KEY}->from                   ,$KEY          ,$TUSER{$KEY}->amount,$TUSER{$KEY}->size
.

format ALL_TOP =
 Size/Message                                                                          Total msg    Total size
--------------------------------------------------------------------------------------------------------------
.

format ALL =
 @<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<< @||||||||||| @>>>>>>>>>>
 int($TOTAL_S/$TOTAL_MSG)                                                               $TOTAL_MSG   $TOTAL_S
.

########################################
# End of format Output
########################################


# Main execution
OPEN_LOG();
Get_all();
Sort_logs();















